////////////////////////////////////////////////////////////////////////////////
// Copyright (c) Elektrobit Automotive GmbH
// Alle Rechte vorbehalten. All Rights Reserved.
//
// Information contained herein is subject to change without notice.
// Elektrobit retains ownership and all other rights in the software and each
// component thereof.
// Any reproduction of the software or components thereof without the prior
// written permission of Elektrobit is prohibited.
////////////////////////////////////////////////////////////////////////////////

#ifndef CUSTOM_EFFECT_STACK_FRAME_H_INCLUDED
#define CUSTOM_EFFECT_STACK_FRAME_H_INCLUDED

#include <gtf/scdr/Allocator.h>
#include <gtf/scdr/RenderObjectStackFrame.h>

class CustomEffectStackFrame : public gtf::scdr::RenderObjectStackFrame2D
{
public:
    CustomEffectStackFrame();
    virtual ~CustomEffectStackFrame();

    virtual void load(gtf::scdr::RenderObjectStackFrame2DValues& valuesOut_) const;

public:
    gtf::scdr::Viewport     viewport;
    gtf::math::float4x4     viewProjMat;
    gtf::math::float4x4     framebuffer2Screen;
    gtf::math::float4x4     widget2Framebuffer;
    gtf::scdr::Scissor      scissor;
    gtf::scdr::Color        coloration;
    gtf::scdr::Framebuffer* framebuffer;
    uint32_t                framebufferId;
    uint32_t*               depth;
};

#endif
