////////////////////////////////////////////////////////////////////////////////
// Copyright (c) Elektrobit Automotive GmbH
// Alle Rechte vorbehalten. All Rights Reserved.
//
// Information contained herein is subject to change without notice.
// Elektrobit retains ownership and all other rights in the software and each
// component thereof.
// Any reproduction of the software or components thereof without the prior
// written permission of Elektrobit is prohibited.
////////////////////////////////////////////////////////////////////////////////

#ifndef GTF_EXTENDED_CONTAINER_WIDGET_H_INCLUDED
#define GTF_EXTENDED_CONTAINER_WIDGET_H_INCLUDED

#include <gtf/widgetset/AbstractWidget.h>
#include <gtf/widgetset/WidgetModel.h>
#include <gtf/viewfactory/ViewFactory.h>

extern gtf::widgetset::AbstractWidget* createExtendedContainerInstance(
    gtf::widgetset::WidgetContext const& ctx_,
    gtf::widgetset::WidgetModel& model_);

extern void destroyExtendedContainerInstance(gtf::widgetset::AbstractWidget* widget_);

class GtfExtendedContainerWidget : public gtf::widgetset::AbstractWidget
{
public:
    GtfExtendedContainerWidget(gtf::widgetset::WidgetModel& model,
                               gtf::widgetset::WidgetContext const& ctx);
    ~GtfExtendedContainerWidget();
    GtfExtendedContainerWidget & operator=(const GtfExtendedContainerWidget &) { return *this; }

    virtual void init(gtf::widgetset::WidgetContext const&context);
    virtual void prepare(gtf::widgetset::WidgetContext const&context);
    virtual void cleanup(gtf::widgetset::WidgetContext const&context);

protected:
    void handleUpdate();

private:
    bool isInitialized;
    bool propertyReferencesResolved;

    gtf::widgetset::WidgetModel& model;
    gtf::widgetset::WidgetContext const& ctx;

    struct PropertyReferences
    {
        enum Value
        {
            DisplayStatus = 0,
            IsVisible = 1,
            Count = 2
        };
    };

    gtf::viewfactory::ViewFactory::WidgetPropertyReference widgetPropRefs[PropertyReferences::Count];
};

#endif // GTF_EXTENDED_CONTAINER_WIDGET_H_INCLUDED
