////////////////////////////////////////////////////////////////////////////////
// Copyright (c) Elektrobit Automotive GmbH
// Alle Rechte vorbehalten. All Rights Reserved.
//
// Information contained herein is subject to change without notice.
// Elektrobit retains ownership and all other rights in the software and each
// component thereof.
// Any reproduction of the software or components thereof without the prior
// written permission of Elektrobit is prohibited.
////////////////////////////////////////////////////////////////////////////////

#ifndef GTF_EXTENDEND_CONTAINER_WIDGET_DESC_H_INCLUDED
#define GTF_EXTENDEND_CONTAINER_WIDGET_DESC_H_INCLUDED

#include <gtf/metainfo/DescriptorProvider.h>
#include "ExtendedContainerWidget.h"

class ExtendedContainerWidgetDesc : public gtf::metainfo::DescriptorProvider
{
public:
    virtual gtf::metainfo::ActionDescriptor const* GetActions(uint32_t& count_) const;
    virtual gtf::metainfo::PopupStackDescriptor const* GetPopupStacks(uint32_t& count_) const;
    virtual gtf::metainfo::MediatorDescriptor const* GetMediators(uint32_t& count_) const;
    virtual gtf::metainfo::WidgetDescriptor const* GetWidgets(uint32_t& count_) const;
    virtual gtf::metainfo::WidgetFeatureDescriptor const* GetWidgetFeatures(uint32_t& count_) const;
    virtual gtf::metainfo::ResourceDescriptor const* GetResourceTypes(uint32_t& count_) const;
    virtual bool ResolveTypes(const gtf::type::TypeManager* typeManager_);
};

#endif // GTF_EXTENDEND_CONTAINER_WIDGET_DESC_H_INCLUDED
