////////////////////////////////////////////////////////////////////////////////
// Copyright (c) Elektrobit Automotive GmbH
// Alle Rechte vorbehalten. All Rights Reserved.
//
// Information contained herein is subject to change without notice.
// Elektrobit retains ownership and all other rights in the software and each
// component thereof.
// Any reproduction of the software or components thereof without the prior
// written permission of Elektrobit is prohibited.
////////////////////////////////////////////////////////////////////////////////

#ifndef GTF_FOCUSED_WIDGET_FEATURE_H_INCLUDED
#define GTF_FOCUSED_WIDGET_FEATURE_H_INCLUDED

#include <gtf/widgetset/AbstractWidget.h>
#include <gtf/widgetset/WidgetModel.h>
#include <gtf/viewfactory/ViewFactory.h>

extern gtf::widgetset::AbstractWidgetFeature* createFocusRectColorInstance(gtf::widgetset::WidgetFeatureModel& model,
    gtf::widgetset::WidgetContext const& ctx);

extern void destroyFocusRectColorInstance(gtf::widgetset::AbstractWidgetFeature* widget);

class FocusRectColorFeature : public gtf::widgetset::AbstractWidgetFeature
{
public:
    FocusRectColorFeature(gtf::widgetset::WidgetFeatureModel& model,
        gtf::widgetset::WidgetContext const& ctx_);
    ~FocusRectColorFeature();

    virtual void init(gtf::widgetset::WidgetContext const & context);
    virtual void prepare(gtf::widgetset::WidgetContext const & context);
    virtual void hide(gtf::widgetset::WidgetContext const & context);

protected:
    void handleUpdate(gtf::widgetset::WidgetFeatureModel* focusRect,
        gtf::widgetset::WidgetModel* widgetModel);

private:
    bool isInitialized;
    bool referencesResolved;
    uint32_t fillColor;

    gtf::widgetset::WidgetFeatureModel& featureModel;
    gtf::widgetset::WidgetContext const& ctx;

    struct FeaturePropertyReferences
    {
        enum
        {
            FeaturePropFocusedColor = 0
            , Focused
            , FeaturePropMAX
        };
    };

    gtf::viewfactory::ViewFactory::FeaturePropertyReference featurePropertyReferences[FeaturePropertyReferences::FeaturePropMAX];

    struct PropertyReferences
    {
        enum
        {
            FillColor
            , WidgetPropMAX
        };
    };

    gtf::viewfactory::ViewFactory::WidgetPropertyReference widgetPropertyReferences[PropertyReferences::WidgetPropMAX];
};

#endif // GTF_FOCUSED_WIDGET_FEATURE_H_INCLUDED
