////////////////////////////////////////////////////////////////////////////////
// Copyright (c) Elektrobit Automotive GmbH
// Alle Rechte vorbehalten. All Rights Reserved.
//
// Information contained herein is subject to change without notice.
// Elektrobit retains ownership and all other rights in the software and each
// component thereof.
// Any reproduction of the software or components thereof without the prior
// written permission of Elektrobit is prohibited.
////////////////////////////////////////////////////////////////////////////////

#ifndef CUSTOM_WIDGET_TRIANGLE_DIRECTX_SHADER_H_INCLUDED
#define CUSTOM_WIDGET_TRIANGLE_DIRECTX_SHADER_H_INCLUDED

static const char* VertexShaderD3D11 =
"cbuffer TriangleParameters : register(b0)                "
"{                                                        "
"    float4x4 uProjMat;                                   "
"    float4x4 uModelMat;                                  "
"    float4   uColor;                                     "
"};                                                       "
"struct VS_IN                                             "
"{                                                        "
"    float2 pos : aPosition0;                             "
"};                                                       "
"struct VS_OUT                                            "
"{                                                        "
"    float4 pos : SV_POSITION;                            "
"    nointerpolation float4 color : COLOR0;               "
"};                                                       "
"VS_OUT main(VS_IN vsIn)                                  "
"{                                                        "
"    VS_OUT vsOut = (VS_OUT)0;                            "
"    float4 wpos = float4(vsIn.pos.x,vsIn.pos.y,0.f,1.f); "
"    float4 viewPos = mul(uModelMat, wpos);               "
"    vsOut.pos = mul(uProjMat, viewPos);                  "
"    vsOut.color = uColor;                                "
"    return vsOut;                                        "
"};                                                       ";

static const char* PixelShaderD3D11 =
"struct PS_IN                                             "
"{                                                        "
"    float4 pos : SV_POSITION;                            "
"    nointerpolation float4 color : COLOR0;               "
"};                                                       "
"float4 main(PS_IN psIn) : SV_TARGET0                     "
"{                                                        "
"    return psIn.color;                                   "
"}                                                        ";

#endif // CUSTOM_WIDGET_TRIANGLE_DIRECTX_SHADER_H_INCLUDED
