////////////////////////////////////////////////////////////////////////////////
// Copyright (c) Elektrobit Automotive GmbH
// Alle Rechte vorbehalten. All Rights Reserved.
//
// Information contained herein is subject to change without notice.
// Elektrobit retains ownership and all other rights in the software and each
// component thereof.
// Any reproduction of the software or components thereof without the prior
// written permission of Elektrobit is prohibited.
////////////////////////////////////////////////////////////////////////////////

#ifndef CUSTOM_WIDGET_TRIANGLE_GLES3_SHADER_H_INCLUDED
#define CUSTOM_WIDGET_TRIANGLE_GLES3_SHADER_H_INCLUDED

static const char* VertexShaderGLES3 =
"layout (std140) uniform TriangleParameters            \n" \
"{                                                     \n" \
"    uniform highp mat4 uProjMat;                      \n" \
"    uniform highp mat4 uModelMat;                     \n" \
"    uniform lowp vec4 uColor;                         \n" \
"};                                                    \n" \
"                                                      \n" \
"layout (location = 0) in highp vec2 aPosition;        \n" \
"                                                      \n" \
"void main()                                           \n" \
"{                                                     \n" \
"    vec4 pos = uModelMat * vec4(aPosition, 0.0, 1.0); \n" \
"    gl_Position = uProjMat * pos;                     \n" \
"}                                                     \n";

static const char* FragmentShaderGLES3 =
"layout (std140) uniform TriangleParameters            \n" \
"{                                                     \n" \
"    uniform highp mat4 uProjMat;                      \n" \
"    uniform highp mat4 uModelMat;                     \n" \
"    uniform lowp vec4 uColor;                         \n" \
"};                                                    \n" \
"                                                      \n" \
"out highp vec4 fragmentColor;                         \n" \
"                                                      \n" \
"void main()                                           \n" \
"{                                                     \n" \
"    fragmentColor = uColor;                           \n" \
"}                                                     \n";

#endif // CUSTOM_WIDGET_TRIANGLE_GLES3_SHADER_H_INCLUDED
